<template>
  <label class="input-switch">

    <slot name="unchecked" v-if="activeLabels">
      <div class="input-switch__label">
        off
      </div>
    </slot>

    <div class="input-switch__wrapper">
      <img
        :class="`input-switch__button input-switch__button--${isActive}`"
        src="/handDrawSquare.svg"
      />
    </div>

    <slot name="checked" v-if="activeLabels">
      <div class="input-switch__label">
        on
      </div>
    </slot>

     <input
      class="input-switch__checkbox"
      type="checkbox"
      id="checkbox"
      :checked="value"
      @input="updateSwitchValue($event.target.checked)"
    />
  </label>
</template>

<script>
export default {
  name: 'InputSwitch',
  props: {
    value: { type: Boolean, default: false },
    activeLabels: { type: Boolean, default: false }
  },
  methods: {
    updateSwitchValue(value) {
      this.$emit('input', value);
    }
  },
  computed: {
    isActive() {
      return this.value ? 'active' : 'inactive'
    }
  }
}
</script>

<style lang="scss" scoped>
  .input-switch {
    justify-content: center;
    align-items: center;
    cursor: pointer;
    display: flex;
    gap: 8px;


    &__wrapper {
      background-image: url('/handDrawDiagonalLines.jpg');
      background-size: 70px;
      border: 1px solid black;
      box-sizing: border-box;
      height: 36px;
      position: relative;
      width: 70px;
    }

    &__button {
      position: absolute;
      top: -3px;
      user-select: none;
      width: 40px;

      &--inactive {
        left: -2px;
        animation: inactive .05s linear;
      }

      &--active {
        left: 32px;
        animation: active .05s linear;
      }
    }

    &__checkbox {
      display: none;
    }
  }


  @keyframes active {
    from {
      left: -1px;
    }
    to {
      left: 34px;
    }
  }
  @keyframes inactive {
    from {
      left: 34px;
    }
    to {
      left: -1px;
    }
  }
</style>
